do


 --------------------------------------------------------------
 -----------Globals
 --------------------------------------------------------------
  
    ScriptVersionNumber = "1.0.0" --Version number displayed on load
 
    SecondsMessagesDisplayed = 90 --How many seconds that report messages stay on screen
    ControllerGuidanceActive = false --While true a controller will send bearings to nearest intercept target
    ControllerGuidanceInterval = 2 --Seconds between intercept controller updates
    BlueFighterGroup = nil
    PlayerGroupName = "Dodge" --Name of group used by the player
   
    RedGroups = {} --Table where Reds are stored
    WhiteGroups = {} --Table where Neutrals are stored

    BullsCoordinate = COORDINATE.GetBullseyeCoordinate( coalition.side.BLUE ) --coordinate of blue bullseye
    BullsPointVec2 =  POINT_VEC2:NewFromVec2( BullsCoordinate:GetVec2() ) --POINT_VEC2:NewFromVec3( coalition.getMainRefPoint( coalition.side.BLUE ) )

    MagneticDeclination = 0 --Magnetic declination for the map; Default is here but it will be set at mission start to the current map's value as shown in "MagDecTable"
 
    DebugSlantRange = 0 --Debug var for checking range calculations
    CyclesInEscortWindow = 0 --Number of guidance windows that the fighter was within the close range area near the intercept target 
    CyclesNeededForEscort = 4 --How many cycles a fighter needs to be in place before the target is considered escorted
    AspectForEscort = 9 --Minimum aspect angle to be considered escorting
    MaxEscortRange = 500 --Maximum range (in meters) from target to be in escort window
    MaxEscortAltDiff = 250 --Maximum difference in altitude with TOI to be considered escorting (in meters)
    MinTOIFlightAlt = 4000 --Minimum MSL (in meters) that a TOI can spawn at
    MaxTOIFlightAlt = 6000 --Minimum MSL (in meters) that a TOI can spawn at

    local MenuLeave = {} --object ref for leave radio command (so we can remove it when we no longer need it)    
    InterceptStatus = "CAPORBIT" --Tracker for stages of intercept (and accompanying logic)
    --Valid states are: CAPORBIT COMMITCATA OFFSET20 PUREPURSUIT CONTROLZONE PREESCORT ESCORTING TOIEXIT RETURNTOCAP
    InterceptTip = "" --Tip that is displayed below data (for example "Set CATA" or "Get 12AA by 6-8 miles")
    DebugMode = false --True to display debug extras
 
 --------------------------------------------------------------
 ----The following need to be added in the ME:
 --"ZoneRed" One or more zones with this in the name
 --"ZoneNeutral" One or more zones with this in the name
 --"Red Template" One or more red air groups with this in the name (late activated)
 --"White Template" One or more neutral air groups with this in the name (late activated)
 --"Red Air" One or more red air groups with this in the name (late activated); Path it across an interception point
 --"White Air" One or more white air groups with this in the name (late activated); Path it across an interception point
 --------------------------------------------------------------   

 --[[
 Intercept code update:
1. Need a basic solo practice - neutral a/c flying straight line [DONE]
2. Two start zones: northbound and southbound [DONE]
3. Northern arc of destination zones and southern arc of destination zones; can pick pairs of these for #1 [DONE]
4. [MAYBE]"Jinking" bogey. Neutral a/c that turns sharply partway through intercept before going back to destination zone (ie to fly around DCA)
5. [MAYBE] Add intermediate zones that will be added to bogey flight path between begin and end zone
6. [MAYBE] Add jink zone to north and south of intermediate zones
7. [MAYBE] Jinking bogey will pick a start zone, intermediate zone, jink zone, then destination zone
8. When within intercept radius of bogey, bring up radio option to order bogey away.
9. New radio command gives bogey new travel coordinate of despawn zone
10. Pull the first blue unit from blue air instead of a hardcoded group name [Search for "TODO"]
]]

--------------------------------------------------------------
-----------Template Setup
--------------------------------------------------------------
    
    --Create Zone Sets
    SetZoneRed = SET_ZONE:New():FilterPrefixes( "ZoneRed" ):FilterStart()
    SetZoneNeutral = SET_ZONE:New():FilterPrefixes( "ZoneNeutral" ):FilterStart() 
    
    SetZoneNorthBound = SET_ZONE:New():FilterPrefixes( "ZoneNB" ):FilterStart()
    SetZoneSouthBound = SET_ZONE:New():FilterPrefixes( "ZoneSB" ):FilterStart()
    SetZoneDestinationNorth = SET_ZONE:New():FilterPrefixes( "ZoneDestN" ):FilterStart()
    SetZoneDestinationSouth = SET_ZONE:New():FilterPrefixes( "ZoneDestS" ):FilterStart()
    SetZoneDespawn = SET_ZONE:New():FilterPrefixes( "ZoneDespawn" ):FilterStart()


    ZoneTableRed = {}
    SetZoneRed:ForEachZone( 
    function( ZoneObject )
        ZoneTableRed[#ZoneTableRed + 1] = ZoneObject
    end )

    ZoneTableNeutral = {}
    SetZoneNeutral:ForEachZone( 
    function( ZoneObject )
        ZoneTableNeutral[#ZoneTableNeutral + 1] = ZoneObject
    end )

    ZoneTableSouthBound = {}
    SetZoneSouthBound:ForEachZone( 
    function( ZoneObject )
        ZoneTableSouthBound[#ZoneTableSouthBound + 1] = ZoneObject
    end )

    ZoneTableNorthBound = {}
    SetZoneNorthBound:ForEachZone( 
    function( ZoneObject )
        ZoneTableNorthBound[#ZoneTableNorthBound + 1] = ZoneObject
    end )

    ZoneTableDestNorth = {}
    SetZoneDestinationNorth:ForEachZone( 
    function( ZoneObject )
        ZoneTableDestNorth[#ZoneTableDestNorth + 1] = ZoneObject
    end )

    ZoneTableDestSouth = {}
    SetZoneDestinationSouth:ForEachZone( 
    function( ZoneObject )
        ZoneTableDestSouth[#ZoneTableDestSouth + 1] = ZoneObject
    end )

    ZoneTableDespawn = {}
    SetZoneDestinationSouth:ForEachZone( 
    function( ZoneObject )
        ZoneTableDespawn[#ZoneTableDespawn + 1] = ZoneObject
    end )
 

    --Create spawn templates
    SetRedGroups = SET_GROUP:New():FilterCoalitions("red"):FilterPrefixes("Red Template"):FilterOnce()
    SetNeutralGroups = SET_GROUP:New():FilterCoalitions("neutral"):FilterPrefixes("White Template"):FilterOnce()

    TemplateTableRed = {}
    SetRedGroups:ForEachGroup( 
    function( GroupObject )
      TemplateTableRed[#TemplateTableRed + 1] = GroupObject.GroupName 	
    end )	

    TemplateTableNeutral = {}
    SetNeutralGroups:ForEachGroup( 
    function( GroupObject )
      TemplateTableNeutral[#TemplateTableNeutral + 1] = GroupObject.GroupName 	
    end )	


    --Spawn targets; Gather up all the targets for the group templates so they can be chosen at random during activation
    SpawnRedGroups = SET_GROUP:New():FilterPrefixes("Red Air"):FilterOnce()
    SpawnNeutralGroups = SET_GROUP:New():FilterPrefixes("White Air"):FilterOnce()

    SpawnTableRed = {}
    SpawnRedGroups:ForEachGroup( 
    function( GroupObject )
      SpawnTableRed[#SpawnTableRed + 1] = GroupObject.GroupName 	
    end )

    SpawnTableNeutral = {}
    SpawnNeutralGroups:ForEachGroup( 
    function( GroupObject )
      SpawnTableNeutral[#SpawnTableNeutral + 1] = GroupObject.GroupName 	
    end )


--------------------------------------------------------------
-----------Controller Callouts Logic
--------------------------------------------------------------

function InterceptGuidanceCall()
  MESSAGE:New( "InterceptGuidanceCall entered", SecondsMessagesDisplayed):ToAll()
    --BlueFighterGroup is set in the spawn call. Should contain all player fighters
    local BlueUnit = BlueFighterGroup:GetFirstUnitAlive()
    MESSAGE:New( "Got Blue", SecondsMessagesDisplayed):ToAll()
    local RedAirSet = SET_GROUP:New():FilterCoalitions( "red" ):FilterCategoryAirplane():FilterActive():FilterOnce()
    MESSAGE:New( "Got Red", SecondsMessagesDisplayed):ToAll()
    local AllAirSet = SET_GROUP:New():FilterCoalitions( "neutral" ):FilterCategoryAirplane():FilterActive():FilterOnce()
    MESSAGE:New( "Get All Group Sets", SecondsMessagesDisplayed):ToAll()
    AllAirSet = AllAirSet:AddSet(RedAirSet)
    local InterceptGroup = AllAirSet:FindNearestGroupFromPointVec2( BullsPointVec2 )
    --local RedGroup = 
    local InterceptTargetCoordinate
    local InterceptPointCoordinate
    
    local FirstInterceptUnit = InterceptGroup:GetFirstUnitAlive()
    MESSAGE:New( "Get First Intercept Unit", SecondsMessagesDisplayed):ToAll()
    --local FirstInterceptUnit = InterceptGroup:GetUnits(1)
    if(FirstInterceptUnit ~= nil) then
      InterceptTargetCoordinate = FirstInterceptUnit:GetCoordinate()
      --Unit:GetHeading returns a number and a nil for unit existing or not
      local BESlant = BullsCoordinate:Get3DDistance(InterceptTargetCoordinate)
      local BESlant = math.ceil( BESlant / 1852 ) -- convert meters to nm and round up
      local BullsDirectionVec3 = BullsCoordinate:GetDirectionVec3( InterceptTargetCoordinate )
      local BullsAngle = math.ceil( COORDINATE:GetAngleDegrees( BullsDirectionVec3 ) )
      MESSAGE:New( "BULLSEYE adjusting for MagVar", SecondsMessagesDisplayed):ToAll() 
      BullsAngle = AdjustForMagVar( BullsAngle, BullsCoordinate )
      MESSAGE:New( "BULLSEYE after adjusting for MagVar", SecondsMessagesDisplayed):ToAll() 
      local InterceptAltitude = FirstInterceptUnit:GetAltitude() * 3.28
      local RoundedAltitude = math.floor(InterceptAltitude / 1000 ) * 1000 --TODO: This rounds down. So 14,999 is 14,000. Should be 500 goes up.
      MESSAGE:New( "BULLSEYE " .. ThreeDigitFormat( BullsAngle ) .. "/" .. BESlant, SecondsMessagesDisplayed):Clear():ToAll() 

      local BlueSpeed = BlueUnit:GetVelocityMPS()
      local BlueCoord = BlueUnit:GetCoordinate()
      local IntSlantMeters = math.ceil( InterceptTargetCoordinate:Get3DDistance( BlueCoord ) )
      local IntSlantNauts = math.ceil ( IntSlantMeters / 1852 )
      local TimeToIntercept = math.ceil( IntSlantMeters / BlueSpeed )
      --MESSAGE:New( "TOI Range(nm): " .. IntSlantNauts .. " TTI(s): " .. TimeToIntercept , SecondsMessagesDisplayed):ToAll() 

      local TOIVec3 = BlueCoord:GetDirectionVec3( InterceptTargetCoordinate )
      local TOIAngle =  math.ceil( COORDINATE:GetAngleDegrees( TOIVec3 ) )
      --Adjust for magnetic variance      
      TOIAngle = AdjustForMagVar( TOIAngle, BlueCoord )

      local AngleToBlueVec3 = InterceptTargetCoordinate:GetDirectionVec3( BlueCoord )
      local AngleToBlue = math.ceil( COORDINATE:GetAngleDegrees( AngleToBlueVec3 ) )
      local IntHeading = FirstInterceptUnit:GetHeading()
      local HeadingReciprocal = IntHeading - 180
      if(HeadingReciprocal < 0) then
        HeadingReciprocal = 360 + HeadingReciprocal
      end


      local AdjustedAngle = AngleToBlue - HeadingReciprocal
      local AspectAngle
      local AspectLetter
      local DebugCase = "R1"

      if (AdjustedAngle >= 0 and AdjustedAngle <= 180) then --This is a left side AA
        AspectAngle = AdjustedAngle
        AspectLetter = "L"
        DebugCase = "L1"
      end

      if (AdjustedAngle < 0 ) then --We need a positive number to do an AA calculation; note: negatives are also right side AA and will be handled below
        AdjustedAngle = 360 + AdjustedAngle   
        DebugCase = "R2"     
      end

      if (AdjustedAngle > 180 and AdjustedAngle <= 360) then --This is a right side AA
        AspectAngle = 360 - AdjustedAngle
        AspectLetter = "R"        
      end

      AspectAngle = math.ceil( AspectAngle / 10 ) --Get tenth of AA rounded up

      MESSAGE:New( "BRAA " .. ThreeDigitFormat( TOIAngle ) .. "/" .. IntSlantNauts .. " " .. RoundedAltitude .. " " .. AspectAngle .. AspectLetter, SecondsMessagesDisplayed):ToAll() 
      --MESSAGE:New( "Bearing: " .. ThreeDigitFormat( TOIAngle ) .. " Aspect: " .. AspectAngle .. AspectLetter, SecondsMessagesDisplayed):ToAll() 
      --MESSAGE:New( "Tgt Heading: " .. math.ceil(IntHeading) .. " Reciprocal: " .. math.ceil(HeadingReciprocal) .. " A2B: " .. math.ceil(AngleToBlue) , SecondsMessagesDisplayed):ToAll() 
      --MESSAGE:New( "Case: " .. DebugCase .. " Reciprocal: " .. math.ceil(HeadingReciprocal) .. " A2B: " .. math.ceil(AngleToBlue) , SecondsMessagesDisplayed):ToAll() 
      MESSAGE:New( "TIP: " .. InterceptTip, SecondsMessagesDisplayed):ToAll()
      
      local InEscort
      if( IsInEscortWindow( BlueFighterGroup, InterceptGroup, AspectAngle ) ) then
        InEscort = "Yes"
      else
        InEscort = "No"
      end

      if( InterceptStatus == "RETURNTOCAP" ) then
        ControllerGuidanceActive = false
      end
      
      --Update Intercept Status
      UpdateInterceptStatus( IntSlantNauts, AspectAngle, InEscort)
      
      if DebugMode then
        MESSAGE:New( "Escorting? " .. InEscort .. " " .. CyclesInEscortWindow .. " " .. math.ceil( DebugSlantRange ), SecondsMessagesDisplayed):ToAll() 
        MESSAGE:New( "Status: " .. InterceptStatus, SecondsMessagesDisplayed):ToAll()
      end
    end    

end

function UpdateInterceptStatus( InterceptRange, InterceptAspect, Escorting )
--Valid states are: CAPORBIT COMMITCATA OFFSET20 PUREPURSUIT CONTROLZONE* PREESCORT ESCORTING TOIEXIT RETURNTOCAP
--* not currently used
    if( InterceptStatus == "COMMITCATA" and InterceptRange > 25 ) then
      InterceptTip = "Set CATA"
    end

    if( InterceptStatus == "COMMITCATA" and InterceptRange <= 25 ) then
      InterceptStatus = "OFFSET20"
      InterceptTip =  "Nose behind target / Get 12AA by 6-8 miles" -- "Nose behind target / Get 12AA by 6-8 miles / 12 center scope / 18 outer edge"
    end

    if( InterceptStatus == "OFFSET20" and InterceptRange <= 6 ) then
      InterceptStatus = "PUREPURSUIT"
      InterceptTip = "Pure Pursuit"
    end

    if( InterceptStatus == "PUREPURSUIT" and InterceptRange <= 2 and InterceptAspect < 4 ) then
      InterceptStatus = "PREESCORT"
      InterceptTip = "Fly alongside target"
    end

    if( InterceptStatus == "PREESCORT" and Escorting == "Yes" ) then
      InterceptStatus = "ESCORTING"
      ShowLeaveMenu( BlueFighterGroup )         
      InterceptTip = "NEW RADIO OPTION AVAILABLE: Order Target To Leave"
    end

    if( InterceptStatus == "ESCORTING" and Escorting == "No" ) then
      InterceptStatus = "PREESCORT"
      HideLeaveMenu( BlueFighterGroup )
      InterceptTip = "Fly alongside target"
    end

    if( InterceptStatus == "TOIEXIT" ) then
      InterceptStatus = "RETURNTOCAP" 
      HideLeaveMenu( BlueFighterGroup )            
      InterceptTip = "Return to CAP station"
    end

    if( InterceptStatus == "RETURNTOCAP" ) then                      
      InterceptTip = "Return to CAP station"
    end

end


function IsInEscortWindow( FighterGroup, TargetGroup, AspAng )
  local Output = false
  
  local BlueUnit = FighterGroup:GetFirstUnitAlive()
  local TargetUnit = TargetGroup:GetFirstUnitAlive()
  local BlueCoord = BlueUnit:GetCoordinate()
  local SlantRange = TargetUnit:GetCoordinate():Get3DDistance(BlueCoord)
  local TargetAltitude = TargetUnit:GetAltitude()
  local BlueUnitAltitude = BlueUnit:GetAltitude()
  
  --Reset escort counter if difference in altitude between interceptor and target is greater than max allowable
  if( math.abs(BlueUnitAltitude - TargetAltitude) > MaxEscortAltDiff ) then
    CyclesInEscortWindow = 0
  end
  
  DebugSlantRange = SlantRange
  if( SlantRange < MaxEscortRange and AspAng >= AspectForEscort ) then
    CyclesInEscortWindow = CyclesInEscortWindow + 1
  else
    CyclesInEscortWindow = 0
  end

  if( CyclesInEscortWindow >= CyclesNeededForEscort) then
    Output = true
  end
  

  return Output
end

--Create a new task/waypoint for the intercept target and send it there
--This represents an order to leave the restricted area
function OrderTOIToLeave()
  local AllAirSet = SET_GROUP:New():FilterCoalitions( "neutral" ):FilterCategoryAirplane():FilterActive():FilterOnce()  
  local InterceptGroup = AllAirSet:FindNearestGroupFromPointVec2( BullsPointVec2 )
  --MESSAGE:New( "Leave the area!", SecondsMessagesDisplayed):ToAll() 
  InterceptStatus = "TOIEXIT"  

  local FirstInterceptUnit = InterceptGroup:GetFirstUnitAlive()
  if(FirstInterceptUnit ~= nil) then --make sure the unit is valid
    --MESSAGE:New( FirstInterceptUnit:GetName() .. " is leaving the area", SecondsMessagesDisplayed ):ToAll()     

    local DespawnZone = ZONE:FindByName( "DespawnZone" )
    local DespZoneCoord = DespawnZone:GetRandomCoordinate()
    local DespWaypoint = DespZoneCoord:SetAltitude( FirstInterceptUnit:GetAltitude(), true ) --meters, MSL=true (AGL=false)
    --MESSAGE:New( "Despawn Waypoint Set" , 25):ToAll()
    local RoutePoints = {}    
    RoutePoints[#RoutePoints+1] = DespWaypoint:WaypointAir()
    --MESSAGE:New( "Routepoints set." , 25):ToAll()
      
    InterceptGroup:Route(RoutePoints)
    --MESSAGE:New( "Group routed." , 25):ToAll()
    RouteTask = InterceptGroup:TaskRoute( RoutePoints )
    --MESSAGE:New( "Task created." , 25):ToAll()
    InterceptGroup:SetTask( RouteTask, 1 )
  end
end



--------------------------------------------------------------
-----------Spawn Command Setup
--------------------------------------------------------------

    function SpawnNeutralGroup( GuidanceNeeded )          
            WhiteGroupSpawn = SPAWN:New( SpawnTableNeutral[math.random( #SpawnTableNeutral )] )            
            WhiteGroupSpawn
            :InitRandomizeTemplate( TemplateTableNeutral ) 
            :InitRandomizeZones( ZoneTableNeutral )
            :Spawn()  
    end

    function SpawnRedGroup( GuidanceNeeded )          
          RedGroupSpawn = SPAWN:New( SpawnTableRed[math.random( #SpawnTableRed )] )          
          RedGroupSpawn
          :InitRandomizeTemplate( TemplateTableRed ) 
          :InitRandomizeZones( ZoneTableRed )
          :Spawn()
    end

    function RemoveWhiteGroups()
      local AllAirSet = SET_GROUP:New():FilterCoalitions( "neutral" ):FilterCategoryAirplane():FilterActive():FilterOnce()

      AllAirSet:ForEachGroup( 
        function( GroupObject )
          GroupObject:Destroy() 	
        end )	

    end

    function SpawnLevelOneInterceptTarget( GuidanceNeeded )

      RemoveWhiteGroups()
      ControllerGuidanceActive = FirstCalloutScheduler
      MESSAGE:New( "" , 1):Clear():ToAll()

      --Set player fighter group
      local BlueGroupSet = SET_GROUP:New():FilterCategoryAirplane():FilterCoalitions("blue"):FilterActive():FilterStart()
      BlueFighterGroup = BlueGroupSet:GetFirst()

      LevelOneTarget = SPAWN:New ( "LevelOneTarget" )
      LevelOneTarget:Spawn()

      local FirstCalloutScheduler = SCHEDULER:New( nil, 
        function()          
          MESSAGE:New( "[OVERLORD]: DODGE 11, GROUP BULLSEYE 090/43, 15,000, TRACK WEST, BOGEY SPADES. RECOMMEND DODGE COMMIT." , SecondsMessagesDisplayed):ToAll()
        end, {}, 2
      ) --run in 2 seconds

      
      local SecondCalloutScheduler = SCHEDULER:New( nil, 
        function()
          MESSAGE:New( "[DODGE 11]: DODGE COMMIT." , SecondsMessagesDisplayed):ToAll()          
        end, {}, 6 
      ) --run in 6 seconds

      local GuidanceBitScheduler = SCHEDULER:New( nil, 
        function()
          --turn on guidance if needed          
          if GuidanceNeeded then          
            ControllerGuidanceActive = true
          end          
          InterceptStatus = "COMMITCATA" --increment the phase
        end, {}, 7 
      ) --run in 7 seconds

    end

    function SpawnStraightlineWhiteGroup( GuidanceNeeded )
      
      RemoveWhiteGroups()
      ControllerGuidanceActive = FirstCalloutScheduler
      MESSAGE:New( "" , 1):Clear():ToAll()

      --Set player fighter group
      local BlueGroupSet = SET_GROUP:New():FilterCategoryAirplane():FilterCoalitions("blue"):FilterActive():FilterStart()
      BlueFighterGroup = BlueGroupSet:GetFirst() --GROUP:FindByName(PlayerGroupName)

      local FlightAltitude = math.random( MinTOIFlightAlt, MaxTOIFlightAlt )
      local DestinationDirection = math.random( 1, 20 ) --1-10 is north; 11+ is south

      if DebugMode then
        --MESSAGE:New( "Blue count: " .. BlueFighterGroup:Count() , 25):ToAll()
        MESSAGE:New( "Set alt: " .. FlightAltitude .. " m." .. " Direction: " .. DestinationDirection , 25):ToAll()
      end

      local SpawnZoneList = ZoneTableNorthBound
      if DestinationDirection >= 11 then
        SpawnZoneList = ZoneTableSouthBound --Use the southbound list if 2 is rolled
      end
      local SpawnZone = SpawnZoneList[math.random(1,#SpawnZoneList)]
      local SpawnZoneCoord = SpawnZone:GetRandomCoordinate()
      --MESSAGE:New( "Got SpawnZone." , 25):ToAll()

      local StartWaypoint = SpawnZoneCoord:SetAltitude(FlightAltitude, false) --meters, MSL=true (AGL=false)
      --MESSAGE:New( "First Waypoint." , 25):ToAll()

      WhiteGroupSpawn = SPAWN:New( SpawnTableNeutral[math.random( #SpawnTableNeutral )] )
      local TOI = WhiteGroupSpawn
      :InitRandomizeTemplate( TemplateTableNeutral ) 
      --:SpawnInZone( SpawnZone, true, FlightAltitude+200 , FlightAltitude+310 )
      :SpawnFromVec3( StartWaypoint:GetVec3() )

      --MESSAGE:New( "Group spawned." , 25):ToAll()

      
      
      
      local DestZoneList = ZoneTableDestNorth
      if DestinationDirection == 2 then
        DestZoneList = ZoneTableDestSouth --Use the southbound list if 2 is rolled
      end
      local DestZone = DestZoneList[math.random(1,#DestZoneList)]
      local DestZoneCoord = DestZone:GetRandomCoordinate()
      local DestWaypoint = DestZoneCoord:SetAltitude(FlightAltitude, true) --meters, MSL=true (AGL=false)
      --MESSAGE:New( "Second Waypoint." , 25):ToAll()
      local RoutePoints = {}
      RoutePoints[#RoutePoints+1] = StartWaypoint:WaypointAir()
      RoutePoints[#RoutePoints+1] = DestWaypoint:WaypointAir()
      --MESSAGE:New( "Routepoints set." , 25):ToAll()     
      TOI:Route(RoutePoints)
      --MESSAGE:New( "Group routed." , 25):ToAll()
      RouteTask = TOI:TaskRoute( RoutePoints )
      --MESSAGE:New( "Task created." , 25):ToAll()
      TOI:SetTask( RouteTask, 1 )
      TOI:SetAltitude( FlightAltitude, true ) --meters, "Keep" (Optional) When set to true, will maintain the altitude on passing waypoints.
      --MESSAGE:New( "Task set." , 25):ToAll()
      --RandomAngle = math.random( 1, 360 ) 

      --MESSAGE:New( "Guidance Needed? " .. tostring( GuidanceNeeded )  , 25):ToAll()
      
      local FirstCalloutScheduler = SCHEDULER:New( nil, 
        function()          
          local BEnum = math.random(71,101)
          local BErange = math.random(38,51)          
          local TOIAltInMeters = FlightAltitude * 3.28  
          local TOIAlt = math.floor(TOIAltInMeters / 1000 ) * 1000
      
          MESSAGE:New( "[OVERLORD]: DODGE 11, GROUP BULLSEYE " .. BEnum .. "/" .. BErange .. ", " .. TOIAlt .. "000, TRACK WEST, BOGEY SPADES. RECOMMEND DODGE COMMIT." , SecondsMessagesDisplayed):ToAll()
        end, {}, 2
      ) --run in 2 seconds

      
      local SecondCalloutScheduler = SCHEDULER:New( nil, 
        function()
          MESSAGE:New( "[DODGE 11]: DODGE COMMIT." , SecondsMessagesDisplayed):ToAll()          
        end, {}, 6 
      ) --run in 6 seconds

      local GuidanceBitScheduler = SCHEDULER:New( nil, 
        function()
          --turn on guidance if needed          
          if GuidanceNeeded then          
            ControllerGuidanceActive = true
          end          
          InterceptStatus = "COMMITCATA" --increment the phase
        end, {}, 7 
      ) --run in 7 seconds
    
    if DebugMode then  
      MESSAGE:New( "Controller Guidance Active? " .. tostring( ControllerGuidanceActive )  , 25):ToAll()
    end

    end
--------------------------------------------------------------
-----------Magnetic Declination functions
--------------------------------------------------------------
  function AdjustForMagVar( TrueDegrees, MagCoord )
    
    local AdjustedDegrees = TrueDegrees + math.ceil( MagCoord:GetNorthCorrectionRadians() * 57.3) 
    
    if AdjustedDegrees < 0 then --adjust for negative values
        AdjustedDegrees = 360 - AdjustedDegrees
    end

    return AdjustedDegrees

  end

  function ThreeDigitFormat( Degrees )
    local DigitString = tostring( Degrees )
    --MESSAGE:New( "[3DigFormat]: Degrees:" .. Degrees .. " DigitString:" .. DigitString , 25):ToAll()
    if string.len(DigitString) == 1 then
      DigitString = "0" .. DigitString
    end
    if string.len(DigitString) == 2 then
      DigitString = "0" .. DigitString
    end
    return DigitString
  end

--------------------------------------------------------------
-----------Menu Setup & Management
--------------------------------------------------------------
  
function ShowLeaveMenu( MenuGroup )   
  local MenuGroupName = MenuGroup:GetName()             
  MenuLeave[MenuGroupName] = MENU_GROUP_COMMAND:New( MenuGroup, "Order Aircraft To Leave Area", nil, OrderTOIToLeave, nil )    
end

function HideLeaveMenu( MenuGroup )
  local MenuGroupName = MenuGroup:GetName()             
  MenuLeave[MenuGroupName]:Remove()
end
 
    local function SetupGroupMenus()
      SetMenuGroup = SET_GROUP:New():FilterCoalitions("blue"):FilterActive():FilterOnce()
      --Menus are set up by group so a per group argument can be added to each menu. Then messages can be tailored to only show for that group and not everyone on the server
      SetMenuGroup:ForEachGroup(
          function( AGroup )	
                          
              --MENU_GROUP_COMMAND:New( AGroup, "Neutral Intercept Target", nil, SpawnNeutralGroup, false )
              --MENU_GROUP_COMMAND:New( AGroup, "Red Intercept Target", nil, SpawnRedGroup, false )
              --MENU_GROUP_COMMAND:New( AGroup, "Unguided Intercept Target [Neutral]", nil, SpawnStraightlineWhiteGroup, false )              
              MENU_GROUP_COMMAND:New( AGroup, "Level 1 Intercept", nil, SpawnLevelOneInterceptTarget, true )
              MENU_GROUP_COMMAND:New( AGroup, "Level 2 Intercept", nil, SpawnStraightlineWhiteGroup, true )
              --local MenuLeave --object ref for leave radio command (so we can remove it when we no longer need it)
              --MenuLeave = MENU_GROUP_COMMAND:New( AGroup, "Order Aircraft To Leave Area", nil, OrderTOIToLeave, nil )
              if DebugMode then
                MENU_GROUP_COMMAND:New( AGroup, "Show Leave Option", nil, ShowLeaveMenu, AGroup )
                MENU_GROUP_COMMAND:New( AGroup, "Hide Leave Option", nil, HideLeaveMenu, AGroup )
              end
            
      end)
    end
  
    local function ShowVersionNumber( MessageGroup )
      MESSAGE:New( "[Dynamic Intercepts]: Version number " .. ScriptVersionNumber .. " loaded." , 25):ToGroup( MessageGroup )
    end
    



--SetMagDeclination() --Set the map's magnetic variance
--SetupGroupMenus()
--ShowVersionNumber()

--Setup menus when a player enters an aircraft. Multiplayer safe version --
local BlueFighters = SET_GROUP:New():FilterCategoryAirplane():FilterCoalitions("blue"):FilterActive():FilterStart()
BlueFighters:HandleEvent( EVENTS.PlayerEnterAircraft )
function BlueFighters:OnEventPlayerEnterAircraft( EventData )    
  SetupGroupMenus()  
  ShowVersionNumber(EventData.IniGroup)
end  


----------------------------------------
--Main logic loop
----------------------------------------
local GuidanceScheduler = SCHEDULER:New( nil, 
function()
  if ControllerGuidanceActive then
   InterceptGuidanceCall() --Send a BRAA call to Blue	
  end  
end
, { }, 2, ControllerGuidanceInterval ) --run every X seconds as defined in ControllerGuidanceInterval

end